package com.xxfc.platform.activity.biz;

import cn.hutool.core.bean.BeanUtil;
import com.github.wxiaoqi.security.admin.feign.UserFeign;
import com.github.wxiaoqi.security.admin.feign.dto.AppUserDTO;
import com.github.wxiaoqi.security.admin.feign.rest.UserRestInterface;
import com.github.wxiaoqi.security.common.biz.BaseBiz;
import com.xxfc.platform.activity.dto.ApLogDTO;
import com.xxfc.platform.activity.entity.ActivityPopularizeLog;
import com.xxfc.platform.activity.mapper.ActivityPopularizeLogMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 用户参与推广活动（邀请有礼）的活动记录的记录（日志）
 *
 * @author libin
 * @email 18178966185@163.com
 * @date 2019-07-05 15:23:04
 */
@Service
public class ActivityPopularizeLogBiz extends BaseBiz<ActivityPopularizeLogMapper,ActivityPopularizeLog> implements UserRestInterface {

    @Autowired
    ActivityPopularizeItemBiz activityPopularizeItemBiz;

    @Autowired
	UserFeign userFeign;

	@Override
	public UserFeign getUserFeign() {
		return userFeign;
	}

    public ApLogDTO selectOneApLogDTO(ActivityPopularizeLog entity){
        ActivityPopularizeLog apl = mapper.selectOne(entity);
        if(null != apl) {
            ApLogDTO apLogDTO = BeanUtil.toBean(apl, ApLogDTO.class);
            apLogDTO.setItem(activityPopularizeItemBiz.selectById(apLogDTO.getItemId()));
            return apLogDTO;
        }else {
            return null;
        }
    }

    public List<ActivityPopularizeLog> selectByUserId(Integer popularizeId) {
		AppUserDTO appUserDTO = getAppUser();
		if (appUserDTO == null) {
			return new ArrayList<>();
		}
		Map<String, Object> param = new HashMap<>();
		param.put("userId", appUserDTO.getUserid());
		param.put("popularizeId", popularizeId);
		List<ActivityPopularizeLog> apl = mapper.selectByUserId(param);
		return apl;
	}


}